package com.hcloud.microservice.traced.common;

import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.constant.GlobleConstant;
import com.hcloud.microserver.commoncore.domain.FileDO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.commoncore.service.RedisUtils;
import com.hcloud.microserver.commoncore.util.FileType;
import com.hcloud.microserver.commoncore.util.FileUtil;
import com.hcloud.microservice.org.facade.entity.BaseOrg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.Map;

/**
 * @author xiezt
 */
@Component
public class TracedBaseController extends BaseController {

    @Value("${img.location}")
    private String UPLOAD_FILE_PATH;


    @Autowired
    private RedisUtils redisUtils;

    protected String getUserId(){
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        if(null!=redisMap ){
            return (String) redisMap.get(GlobleConstant.USER_GUID);
        }
        return null;
    }

    protected String getOrgGuid(){
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        if(null!=redisMap ){
            return (String) redisMap.get(GlobleConstant.ORG_GUID);
        }
        return null;
    }

    protected Map getLoginInfo(){
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        if(null!=redisMap ){
            return redisMap;
        }
        return null;
    }

    protected BaseInfoDO initiSaveObject(){
        BaseInfoDO baseInfoDO = new BaseInfoDO();
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        if(accessToke==null || "".equals(accessToke)){return null;}
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        if(null!=redisMap){
            BaseOrg baseOrg = (BaseOrg) redisMap.get(GlobleConstant.ORG_OBJECT);
            String orgGuid = (String) redisMap.get(GlobleConstant.ORG_GUID);
            String userId = (String) redisMap.get(GlobleConstant.USER_GUID);
            baseInfoDO.setFkProductGuid(GlobleConstant.PRODUCT_GUID);
            baseInfoDO.setState(1);
            baseInfoDO.setFkOrgGuid(orgGuid);
            baseInfoDO.setCreateUser(userId);
            baseInfoDO.setModifiedUser(userId);
            baseInfoDO.setCreateTime(new Date());
            baseInfoDO.setModifiedTime(new Date());
            baseInfoDO.setOrgBrevity(baseOrg.getOrgBrevity());
            baseInfoDO.setIco(baseOrg.getIco());
            baseInfoDO.setCodeUrlPrefix(baseOrg.getQrcodeUrlPrefixe());
            baseInfoDO.setOrgName(baseOrg.getOrgName());
            baseInfoDO.setOrgAddress(baseOrg.getOrgAddress());
            baseInfoDO.setPrincipals(baseOrg.getPrincipals());
            baseInfoDO.setTel(baseOrg.getTel());
            baseInfoDO.setRemark(baseOrg.getRemark());
            return baseInfoDO;
        }
        return null;
    }

    /**
     * 更新代码
     * @param file
     * @return
     */
    public ResultVO uploadImageFiles(@RequestParam("file") MultipartFile file,String type){
        String fileName = file.getOriginalFilename();
        fileName = FileUtil.renameToUUID(fileName);
        FileDO sysFile = new FileDO(FileType.fileType(fileName),fileName, new Date());
        try {
            String targetPath = UPLOAD_FILE_PATH;
            if(null!=type && !"".equals(type)){
                sysFile.setUrl(type+sysFile.getUrl());
                targetPath=UPLOAD_FILE_PATH+type;
            }
            FileUtil.uploadFile(file.getBytes(),targetPath , fileName);
        } catch (Exception e) {
            return new ResultVO(ResultEnum.SYS_ERROR);
        }
        return success(sysFile.getUrl());
    }
}
