package com.hcloud.microservice.traced.web;

import com.hcloud.microserver.commoncore.annotation.AuthOrgValidate;
import com.hcloud.microserver.commoncore.annotation.AuthValidate;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microservice.traced.common.TracedBaseController;
import io.swagger.annotations.*;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;

/**
 * @author xiezt
 */
@RestController
@RequestMapping("/web/normal")
@Api(description = "公共操作服务")
public class NormalController extends TracedBaseController {

    private static final String TARGET_IMAGE_DIC_NAME="images/";
    private static final String TARGET_FILE_DIC_NAME="files/";

    @ApiOperation(value = "图片上传",notes = "上传问题图片，图片限制大小10MB")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "file",value = "上传内容",dataType = "MultipartFile")
    })
    @ApiResponse(code = 0,message = "操作成功")
    @AuthOrgValidate
    @PostMapping("/uploadPics")
    public ResponseBase uploadPics(@RequestParam("file") MultipartFile file, HttpServletRequest request){
        ResultVO resultVO = this.uploadImageFiles(file,TARGET_IMAGE_DIC_NAME);
        return responseSuccess(resultVO);
    }

    @ApiOperation(value = "文件上传",notes = "上传文件，文件限制大小10MB")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "file",value = "上传内容",dataType = "MultipartFile")
    })
    @ApiResponse(code = 0,message = "操作成功")
    @AuthOrgValidate
    @PostMapping("/uploadFiles")
    public ResponseBase uploadFiles(@RequestParam("file") MultipartFile file, HttpServletRequest request){
        ResultVO resultVO = this.uploadImageFiles(file,TARGET_FILE_DIC_NAME);
        return responseSuccess(resultVO);
    }
}
